Package org.apache.tools.ant.taskdefs.optional.net

# Class FTP

java.lang.Object
org.apache.tools.ant.ProjectComponent
org.apache.tools.ant.Task
org.apache.tools.ant.taskdefs.optional.net.FTP

All Implemented Interfaces:
  `Cloneable`

public class FTP extends Task
Basic FTP client. Performs the following actions:

- send - send files to a remote server. This is the default action.
- get - retrieve files from a remote server.
- del - delete files from a remote server.
- list - create a file listing.
- chmod - change unix file permissions.
- rmdir - remove directories, if empty, from a remote server.

Note: Some FTP servers - notably the Solaris server - seem to hold data ports open after a "retr" operation, allowing them to timeout instead of shutting them down cleanly. This happens in active or passive mode, and the ports will remain open even after ending the FTP session. FTP "send" operations seem to close ports immediately. This behavior may cause problems on some systems when downloading large sets of files.

Since:
  Ant 1.3

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static class`
  `FTP.Action`
  an action to perform, one of "send", "put", "recv", "get", "del", "delete", "list", "mkdir", "chmod", "rmdir"
  `protected class`
  `FTP.FTPDirectoryScanner`
  internal class allowing to read the contents of a remote file system using the FTP protocol used in particular for ftp get operations differences with DirectoryScanner "" (the root of the fileset) is never included in the included directories followSymlinks defaults to false
  `protected static class`
  `FTP.FTPFileProxy`
  internal class providing a File-like interface to some of the information available from the FTP server
  `static class`
  `FTP.FTPSystemType`
  one of the valid system type keys recognized by the systemTypeKey attribute.
  `static class`
  `FTP.Granularity`
  represents one of the valid timestamp adjustment values recognized by the `timestampGranularity` attribute.
  `static class`
  `FTP.LanguageCode`
  Enumerated class for languages.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected static final String[]`
  `ACTION_STRS`
  `protected static final String[]`
  `ACTION_TARGET_STRS`
  `protected static final int`
  `CHMOD`
  `protected static final String[]`
  `COMPLETED_ACTION_STRS`
  `static final int`
  `DEFAULT_FTP_PORT`
  Default port for FTP
  `protected static final int`
  `DEL_FILES`
  `protected static final int`
  `GET_FILES`
  `protected static final int`
  `LIST_FILES`
  `protected static final int`
  `MK_DIR`
  `protected static final int`
  `RM_DIR`
  `protected static final int`
  `SEND_FILES`
  `protected static final int`
  `SITE_CMD`

  ### Fields inherited from class org.apache.tools.ant.Task

  `target, taskName, taskType, wrapper`

  ### Fields inherited from class org.apache.tools.ant.ProjectComponent

  `description, location, project`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `FTP()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `add(HostnameVerifier hostnameVerifier)`
  `void`
  `addFileset(FileSet set)`
  A set of files to upload or download
  `protected void`
  `checkAttributes()`
  Checks to see that all required parameters are set.
  `protected void`
  `createParents(org.apache.commons.net.ftp.FTPClient ftp, String filename)`
  Creates all parent directories specified in a complete relative pathname.
  `protected void`
  `delFile(org.apache.commons.net.ftp.FTPClient ftp, String filename)`
  Delete a file from the remote host.
  `protected void`
  `doSiteCommand(org.apache.commons.net.ftp.FTPClient ftp, String theCMD)`
  Sends a site command to the ftp server
  `void`
  `execute()`
  Runs the task.
  `protected void`
  `executeRetryable(RetryHandler h, Retryable r, String descr)`
  Executable a retryable object.
  `String`
  `getDefaultDateFormatConfig()`
  `protected void`
  `getFile(org.apache.commons.net.ftp.FTPClient ftp, String dir, String filename)`
  Retrieve a single file from the remote host.
  `String`
  `getRecentDateFormatConfig()`
  `String`
  `getServerLanguageCodeConfig()`
  `String`
  `getServerTimeZoneConfig()`
  `String`
  `getShortMonthNamesConfig()`
  `String`
  `getSystemTypeKey()`
  `protected boolean`
  `isUpToDate(org.apache.commons.net.ftp.FTPClient ftp, File localFile, String remoteFile)`
  Checks to see if the remote file is current as compared with the local file.
  `protected void`
  `listFile(org.apache.commons.net.ftp.FTPClient ftp, BufferedWriter bw, String filename)`
  List information about a single file from the remote host.
  `void`
  `log(String msg, int level)`
  `protected void`
  `makeRemoteDir(org.apache.commons.net.ftp.FTPClient ftp, String dir)`
  Create the specified directory on the remote host.
  `protected String`
  `resolveFile(String file)`
  Correct a file path to correspond to the remote host requirements.
  `protected void`
  `rmDir(org.apache.commons.net.ftp.FTPClient ftp, String dirname)`
  Delete a directory, if empty, from the remote host.
  `protected void`
  `sendFile(org.apache.commons.net.ftp.FTPClient ftp, String dir, String filename)`
  Sends a single file to the remote host.
  `void`
  `setAccount(String pAccount)`
  Sets the login account to use on the specified server.
  `void`
  `setAction(String action)`
  Deprecated.
  since 1.5.x.
  `void`
  `setAction(FTP.Action action)`
  Sets the FTP action to be taken.
  `void`
  `setBinary(boolean binary)`
  If true, uses binary mode, otherwise text mode (default is binary).
  `void`
  `setChmod(String theMode)`
  Sets the file permission mode (Unix only) for files sent to the server.
  `void`
  `setDataTimeout(int dataTimeout)`
  Sets the timeout on the data connection in milliseconds.
  `void`
  `setDefaultDateFormatConfig(String defaultDateFormat)`
  Sets the defaultDateFormatConfig attribute.
  `void`
  `setDepends(boolean depends)`
  Set to true to transmit only files that are new or changed from their remote counterparts.
  `void`
  `setEnableRemoteVerification(boolean b)`
  Whether to verify that data and control connections are connected to the same remote host.
  `void`
  `setIgnoreNoncriticalErrors(boolean ignoreNoncriticalErrors)`
  set the flag to skip errors on directory creation.
  `void`
  `setInitialSiteCommand(String initialCommand)`
  Sets the initialSiteCommand attribute.
  `void`
  `setListing(File listing)`
  The output file for the "list" action.
  `void`
  `setNewer(boolean newer)`
  A synonym for `depends`.
  `void`
  `setPassive(boolean passive)`
  Specifies whether to use passive mode.
  `void`
  `setPassword(String password)`
  Sets the login password for the given user id.
  `void`
  `setPort(int port)`
  Sets the FTP port used by the remote server.
  `void`
  `setPreserveLastModified(boolean preserveLastModified)`
  Set to true to preserve modification times for "gotten" files.
  `void`
  `setRecentDateFormatConfig(String recentDateFormat)`
  Sets the recentDateFormatConfig attribute.
  `void`
  `setRemotedir(String dir)`
  Sets the remote directory where files will be placed.
  `void`
  `setRetriesAllowed(String retriesAllowed)`
  Defines how many times to retry executing FTP command before giving up.
  `void`
  `setSeparator(String separator)`
  Sets the remote file separator character.
  `void`
  `setServer(String server)`
  Sets the FTP server to send files to.
  `void`
  `setServerLanguageCodeConfig(FTP.LanguageCode serverLanguageCode)`
  Sets the serverLanguageCode attribute.
  `void`
  `setServerTimeZoneConfig(String serverTimeZoneId)`
  Sets the serverTimeZoneConfig attribute.
  `void`
  `setShortMonthNamesConfig(String shortMonthNames)`
  Sets the shortMonthNamesConfig attribute
  `void`
  `setSiteCommand(String siteCommand)`
  Sets the siteCommand attribute.
  `void`
  `setSkipFailedTransfers(boolean skipFailedTransfers)`
  If true, enables unsuccessful file put, delete and get operations to be skipped with a warning and the remainder of the files still transferred.
  `void`
  `setSystemTypeKey(FTP.FTPSystemType systemKey)`
  Sets the systemTypeKey attribute.
  `void`
  `setTimeDiffAuto(boolean timeDiffAuto)`
  "true" to find out automatically the time difference between local and remote machine.
  `void`
  `setTimeDiffMillis(long timeDiffMillis)`
  number of milliseconds to add to the time on the remote machine to get the time on the local machine.
  `void`
  `setTimestampGranularity(FTP.Granularity timestampGranularity)`
  Sets the timestampGranularity attribute
  `void`
  `setUmask(String theUmask)`
  Sets the default mask for file creation on a unix server.
  `void`
  `setUseFtps(boolean useFtps)`
  Whether to use ftps instead of ftp.
  `void`
  `setUserid(String userid)`
  Sets the login user id to use on the specified server.
  `void`
  `setVerbose(boolean verbose)`
  Set to true to receive notification about each file as it is transferred.
  `void`
  `setWakeUpTransferInterval(int wakeUpTransferInterval)`
  Sets the time interval when we should automatically call a command triggering a transfer The parameter is in seconds
  `protected void`
  `transferFiles(org.apache.commons.net.ftp.FTPClient ftp)`
  Sends all files specified by the configured filesets to the remote server.
  `protected int`
  `transferFiles(org.apache.commons.net.ftp.FTPClient ftp, FileSet fs)`
  For each file in the fileset, do the appropriate action: send, get, delete, or list.

  ### Methods inherited from class org.apache.tools.ant.Task

  `bindToOwner, getOwningTarget, getRuntimeConfigurableWrapper, getTaskName, getTaskType, getWrapper, handleErrorFlush, handleErrorOutput, handleFlush, handleInput, handleOutput, init, isInvalid, log, log, log, log, maybeConfigure, perform, reconfigure, setOwningTarget, setRuntimeConfigurableWrapper, setTaskName, setTaskType`

  ### Methods inherited from class org.apache.tools.ant.ProjectComponent

  `clone, getDescription, getLocation, getProject, setDescription, setLocation, setProject`

  ### Methods inherited from class java.lang.Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### SEND_FILES

    protected static final int SEND_FILES
    See Also:
      - Constant Field Values

  - ### GET_FILES

    protected static final int GET_FILES
    See Also:
      - Constant Field Values

  - ### DEL_FILES

    protected static final int DEL_FILES
    See Also:
      - Constant Field Values

  - ### LIST_FILES

    protected static final int LIST_FILES
    See Also:
      - Constant Field Values

  - ### MK_DIR

    protected static final int MK_DIR
    See Also:
      - Constant Field Values

  - ### CHMOD

    protected static final int CHMOD
    See Also:
      - Constant Field Values

  - ### RM_DIR

    protected static final int RM_DIR
    See Also:
      - Constant Field Values

  - ### SITE_CMD

    protected static final int SITE_CMD
    See Also:
      - Constant Field Values

  - ### DEFAULT_FTP_PORT

    public static final int DEFAULT_FTP_PORT
    Default port for FTP
    See Also:
      - Constant Field Values

  - ### ACTION_STRS

    protected static final String[] ACTION_STRS

  - ### COMPLETED_ACTION_STRS

    protected static final String[] COMPLETED_ACTION_STRS

  - ### ACTION_TARGET_STRS

    protected static final String[] ACTION_TARGET_STRS

- ## Constructor Details

  - ### FTP

    public FTP()

- ## Method Details

  - ### setRemotedir

    public void setRemotedir(String dir)
    Sets the remote directory where files will be placed. This may be a relative or absolute path, and must be in the path syntax expected by the remote server. No correction of path syntax will be performed.
    Parameters:
      `dir` - the remote directory name.

  - ### setServer

    public void setServer(String server)
    Sets the FTP server to send files to.
    Parameters:
      `server` - the remote server name.

  - ### setPort

    public void setPort(int port)
    Sets the FTP port used by the remote server.
    Parameters:
      `port` - the port on which the remote server is listening.

  - ### setUserid

    public void setUserid(String userid)
    Sets the login user id to use on the specified server.
    Parameters:
      `userid` - remote system userid.

  - ### setUseFtps

    public void setUseFtps(boolean useFtps)
    Whether to use ftps instead of ftp.
    Since:
      1.10.13

  - ### add

    public void add(HostnameVerifier hostnameVerifier)

  - ### setPassword

    public void setPassword(String password)
    Sets the login password for the given user id.
    Parameters:
      `password` - the password on the remote system.

  - ### setAccount

    public void setAccount(String pAccount)
    Sets the login account to use on the specified server.
    Parameters:
      `pAccount` - the account name on remote system
    Since:
      Ant 1.7

  - ### setBinary

    public void setBinary(boolean binary)
    If true, uses binary mode, otherwise text mode (default is binary).
    Parameters:
      `binary` - if true use binary mode in transfers.

  - ### setPassive

    public void setPassive(boolean passive)
    Specifies whether to use passive mode. Set to true if you are behind a firewall and cannot connect without it. Passive mode is disabled by default.
    Parameters:
      `passive` - true is passive mode should be used.

  - ### setVerbose

    public void setVerbose(boolean verbose)
    Set to true to receive notification about each file as it is transferred.
    Parameters:
      `verbose` - true if verbose notifications are required.

  - ### setNewer

    public void setNewer(boolean newer)
    A synonym for `depends`. Set to true to transmit only new or changed files. See the related attributes timediffmillis and timediffauto.
    Parameters:
      `newer` - if true only transfer newer files.

  - ### setTimeDiffMillis

    public void setTimeDiffMillis(long timeDiffMillis)
    number of milliseconds to add to the time on the remote machine to get the time on the local machine. use in conjunction with `newer`
    Parameters:
      `timeDiffMillis` - number of milliseconds
    Since:
      ant 1.6

  - ### setTimeDiffAuto

    public void setTimeDiffAuto(boolean timeDiffAuto)
    "true" to find out automatically the time difference between local and remote machine. This requires right to create and delete a temporary file in the remote directory.
    Parameters:
      `timeDiffAuto` - true = find automatically the time diff
    Since:
      ant 1.6

  - ### setPreserveLastModified

    public void setPreserveLastModified(boolean preserveLastModified)
    Set to true to preserve modification times for "gotten" files.
    Parameters:
      `preserveLastModified` - if true preserver modification times.

  - ### setDepends

    public void setDepends(boolean depends)
    Set to true to transmit only files that are new or changed from their remote counterparts. The default is to transmit all files.
    Parameters:
      `depends` - if true only transfer newer files.

  - ### setSeparator

    public void setSeparator(String separator)
    Sets the remote file separator character. This normally defaults to the Unix standard forward slash, but can be manually overridden using this call if the remote server requires some other separator. Only the first character of the string is used.
    Parameters:
      `separator` - the file separator on the remote system.

  - ### setChmod

    public void setChmod(String theMode)
    Sets the file permission mode (Unix only) for files sent to the server.
    Parameters:
      `theMode` - unix style file mode for the files sent to the remote system.

  - ### setUmask

    public void setUmask(String theUmask)
    Sets the default mask for file creation on a unix server.
    Parameters:
      `theUmask` - unix style umask for files created on the remote server.

  - ### addFileset

    public void addFileset(FileSet set)
    A set of files to upload or download
    Parameters:
      `set` - the set of files to be added to the list of files to be transferred.

  - ### setAction

    @Deprecated public void setAction(String action) throws BuildException
    Deprecated.
    since 1.5.x. setAction(String) is deprecated and is replaced with setAction(FTP.Action) to make Ant's Introspection mechanism do the work and also to encapsulate operations on the type in its own class.
    Sets the FTP action to be taken. Currently accepts "put", "get", "del", "mkdir", "chmod", "list", and "site".
    Parameters:
      `action` - the FTP action to be performed.
    Throws:
      `BuildException` - if the action is not a valid action.

  - ### setAction

    public void setAction(FTP.Action action) throws BuildException
    Sets the FTP action to be taken. Currently accepts "put", "get", "del", "mkdir", "chmod", "list", and "site".
    Parameters:
      `action` - the FTP action to be performed.
    Throws:
      `BuildException` - if the action is not a valid action.

  - ### setListing

    public void setListing(File listing)
    The output file for the "list" action. This attribute is ignored for any other actions.
    Parameters:
      `listing` - file in which to store the listing.

  - ### setSkipFailedTransfers

    public void setSkipFailedTransfers(boolean skipFailedTransfers)
    If true, enables unsuccessful file put, delete and get operations to be skipped with a warning and the remainder of the files still transferred.
    Parameters:
      `skipFailedTransfers` - true if failures in transfers are ignored.

  - ### setIgnoreNoncriticalErrors

    public void setIgnoreNoncriticalErrors(boolean ignoreNoncriticalErrors)
    set the flag to skip errors on directory creation. (and maybe later other server specific errors)
    Parameters:
      `ignoreNoncriticalErrors` - true if non-critical errors should not cause a failure.

  - ### setSystemTypeKey

    public void setSystemTypeKey(FTP.FTPSystemType systemKey)
    Sets the systemTypeKey attribute. Method for setting `FTPClientConfig` remote system key.
    Parameters:
      `systemKey` - the key to be set - BUT if blank the default value of null (which signifies "autodetect") will be kept.
    See Also:
      - `FTPClientConfig`

  - ### setDefaultDateFormatConfig

    public void setDefaultDateFormatConfig(String defaultDateFormat)
    Sets the defaultDateFormatConfig attribute.
    Parameters:
      `defaultDateFormat` - configuration to be set, unless it is null or empty string, in which case ignored.
    See Also:
      - `FTPClientConfig`

  - ### setRecentDateFormatConfig

    public void setRecentDateFormatConfig(String recentDateFormat)
    Sets the recentDateFormatConfig attribute.
    Parameters:
      `recentDateFormat` - configuration to be set, unless it is null or empty string, in which case ignored.
    See Also:
      - `FTPClientConfig`

  - ### setServerLanguageCodeConfig

    public void setServerLanguageCodeConfig(FTP.LanguageCode serverLanguageCode)
    Sets the serverLanguageCode attribute.
    Parameters:
      `serverLanguageCode` - configuration to be set, unless it is null or empty string, in which case ignored.
    See Also:
      - `FTPClientConfig`

  - ### setServerTimeZoneConfig

    public void setServerTimeZoneConfig(String serverTimeZoneId)
    Sets the serverTimeZoneConfig attribute.
    Parameters:
      `serverTimeZoneId` - configuration to be set, unless it is null or empty string, in which case ignored.
    See Also:
      - `FTPClientConfig`

  - ### setShortMonthNamesConfig

    public void setShortMonthNamesConfig(String shortMonthNames)
    Sets the shortMonthNamesConfig attribute
    Parameters:
      `shortMonthNames` - configuration to be set, unless it is null or empty string, in which case ignored.
    See Also:
      - `FTPClientConfig`

  - ### setRetriesAllowed

    public void setRetriesAllowed(String retriesAllowed)
    Defines how many times to retry executing FTP command before giving up. Default is 0 - try once and if failure then give up.
    Parameters:
      `retriesAllowed` - number of retries to allow. -1 means keep trying forever. "forever" may also be specified as a synonym for -1.

  - ### getSystemTypeKey

    public String getSystemTypeKey()
    Returns:
      Returns the systemTypeKey.

  - ### getDefaultDateFormatConfig

    public String getDefaultDateFormatConfig()
    Returns:
      Returns the defaultDateFormatConfig.

  - ### getRecentDateFormatConfig

    public String getRecentDateFormatConfig()
    Returns:
      Returns the recentDateFormatConfig.

  - ### getServerLanguageCodeConfig

    public String getServerLanguageCodeConfig()
    Returns:
      Returns the serverLanguageCodeConfig.

  - ### getServerTimeZoneConfig

    public String getServerTimeZoneConfig()
    Returns:
      Returns the serverTimeZoneConfig.

  - ### getShortMonthNamesConfig

    public String getShortMonthNamesConfig()
    Returns:
      Returns the shortMonthNamesConfig.

  - ### setTimestampGranularity

    public void setTimestampGranularity(FTP.Granularity timestampGranularity)
    Sets the timestampGranularity attribute
    Parameters:
      `timestampGranularity` - The timestampGranularity to set.

  - ### setSiteCommand

    public void setSiteCommand(String siteCommand)
    Sets the siteCommand attribute. This attribute names the command that will be executed if the action is "site".
    Parameters:
      `siteCommand` - The siteCommand to set.

  - ### setInitialSiteCommand

    public void setInitialSiteCommand(String initialCommand)
    Sets the initialSiteCommand attribute. This attribute names a site command that will be executed immediately after connection.
    Parameters:
      `initialCommand` - The initialSiteCommand to set.

  - ### setEnableRemoteVerification

    public void setEnableRemoteVerification(boolean b)
    Whether to verify that data and control connections are connected to the same remote host.
    Parameters:
      `b` - boolean
    Since:
      Ant 1.8.0

  - ### setDataTimeout

    public void setDataTimeout(int dataTimeout)
    Sets the timeout on the data connection in milliseconds. Any negative value is discarded and leaves the default A value of 0 means an infinite timeout
    Parameters:
      `dataTimeout` - int
    Since:
      Ant 1.10.7

  - ### setWakeUpTransferInterval

    public void setWakeUpTransferInterval(int wakeUpTransferInterval)
    Sets the time interval when we should automatically call a command triggering a transfer The parameter is in seconds
    Parameters:
      `wakeUpTransferInterval` - int
    Since:
      Ant 1.10.7

  - ### checkAttributes

    protected void checkAttributes() throws BuildException
    Checks to see that all required parameters are set.
    Throws:
      `BuildException` - if the configuration is not valid.

  - ### executeRetryable

    protected void executeRetryable(RetryHandler h, Retryable r, String descr) throws IOException
    Executable a retryable object.
    Parameters:
      `h` - the retry handler.
      `r` - the object that should be retried until it succeeds or the number of retries is reached.
      `descr` - a description of the command that is being run.
    Throws:
      `IOException` - if there is a problem.

  - ### transferFiles

    protected int transferFiles(org.apache.commons.net.ftp.FTPClient ftp, FileSet fs) throws IOException, BuildException
    For each file in the fileset, do the appropriate action: send, get, delete, or list.
    Parameters:
      `ftp` - the FTPClient instance used to perform FTP actions
      `fs` - the fileset on which the actions are performed.
    Returns:
      the number of files to be transferred.
    Throws:
      `IOException` - if there is a problem reading a file
      `BuildException` - if there is a problem in the configuration.

  - ### transferFiles

    protected void transferFiles(org.apache.commons.net.ftp.FTPClient ftp) throws IOException, BuildException
    Sends all files specified by the configured filesets to the remote server.
    Parameters:
      `ftp` - the FTPClient instance used to perform FTP actions
    Throws:
      `IOException` - if there is a problem reading a file
      `BuildException` - if there is a problem in the configuration.

  - ### resolveFile

    protected String resolveFile(String file)
    Correct a file path to correspond to the remote host requirements. This implementation currently assumes that the remote end can handle Unix-style paths with forward-slash separators. This can be overridden with the `separator` task parameter. No attempt is made to determine what syntax is appropriate for the remote host.
    Parameters:
      `file` - the remote file name to be resolved
    Returns:
      the filename as it will appear on the server.

  - ### createParents

    protected void createParents(org.apache.commons.net.ftp.FTPClient ftp, String filename) throws IOException, BuildException
    Creates all parent directories specified in a complete relative pathname. Attempts to create existing directories will not cause errors.
    Parameters:
      `ftp` - the FTP client instance to use to execute FTP actions on the remote server.
      `filename` - the name of the file whose parents should be created.
    Throws:
      `IOException` - under non documented circumstances
      `BuildException` - if it is impossible to cd to a remote directory

  - ### isUpToDate

    protected boolean isUpToDate(org.apache.commons.net.ftp.FTPClient ftp, File localFile, String remoteFile) throws IOException, BuildException
    Checks to see if the remote file is current as compared with the local file. Returns true if the target file is up to date.
    Parameters:
      `ftp` - ftpclient
      `localFile` - local file
      `remoteFile` - remote file
    Returns:
      true if the target file is up to date
    Throws:
      `IOException` - in unknown circumstances
      `BuildException` - if the date of the remote files cannot be found and the action is GET_FILES

  - ### doSiteCommand

    protected void doSiteCommand(org.apache.commons.net.ftp.FTPClient ftp, String theCMD) throws IOException, BuildException
    Sends a site command to the ftp server
    Parameters:
      `ftp` - ftp client
      `theCMD` - command to execute
    Throws:
      `IOException` - in unknown circumstances
      `BuildException` - in unknown circumstances

  - ### sendFile

    protected void sendFile(org.apache.commons.net.ftp.FTPClient ftp, String dir, String filename) throws IOException, BuildException
    Sends a single file to the remote host. `filename` may contain a relative path specification. When this is the case, `sendFile` will attempt to create any necessary parent directories before sending the file. The file will then be sent using the entire relative path spec - no attempt is made to change directories. It is anticipated that this may eventually cause problems with some FTP servers, but it simplifies the coding.
    Parameters:
      `ftp` - ftp client
      `dir` - base directory of the file to be sent (local)
      `filename` - relative path of the file to be send locally relative to dir remotely relative to the remotedir attribute
    Throws:
      `IOException` - in unknown circumstances
      `BuildException` - in unknown circumstances

  - ### delFile

    protected void delFile(org.apache.commons.net.ftp.FTPClient ftp, String filename) throws IOException, BuildException
    Delete a file from the remote host.
    Parameters:
      `ftp` - ftp client
      `filename` - file to delete
    Throws:
      `IOException` - in unknown circumstances
      `BuildException` - if skipFailedTransfers is set to false and the deletion could not be done

  - ### rmDir

    protected void rmDir(org.apache.commons.net.ftp.FTPClient ftp, String dirname) throws IOException, BuildException
    Delete a directory, if empty, from the remote host.
    Parameters:
      `ftp` - ftp client
      `dirname` - directory to delete
    Throws:
      `IOException` - in unknown circumstances
      `BuildException` - if skipFailedTransfers is set to false and the deletion could not be done

  - ### getFile

    protected void getFile(org.apache.commons.net.ftp.FTPClient ftp, String dir, String filename) throws IOException, BuildException
    Retrieve a single file from the remote host. `filename` may contain a relative path specification.

    The file will then be retrieved using the entire relative path spec - no attempt is made to change directories. It is anticipated that this may eventually cause problems with some FTP servers, but it simplifies the coding.

    Parameters:
      `ftp` - the ftp client
      `dir` - local base directory to which the file should go back
      `filename` - relative path of the file based upon the ftp remote directory and/or the local base directory (dir)
    Throws:
      `IOException` - in unknown circumstances
      `BuildException` - if skipFailedTransfers is false and the file cannot be retrieved.

  - ### listFile

    protected void listFile(org.apache.commons.net.ftp.FTPClient ftp, BufferedWriter bw, String filename) throws IOException, BuildException
    List information about a single file from the remote host. `filename` may contain a relative path specification.

    The file listing will then be retrieved using the entire relative path spec - no attempt is made to change directories. It is anticipated that this may eventually cause problems with some FTP servers, but it simplifies the coding.

    Parameters:
      `ftp` - ftp client
      `bw` - buffered writer
      `filename` - the directory one wants to list
    Throws:
      `IOException` - in unknown circumstances
      `BuildException` - in unknown circumstances

  - ### makeRemoteDir

    protected void makeRemoteDir(org.apache.commons.net.ftp.FTPClient ftp, String dir) throws IOException, BuildException
    Create the specified directory on the remote host.
    Parameters:
      `ftp` - The FTP client connection
      `dir` - The directory to create (format must be correct for host type)
    Throws:
      `IOException` - in unknown circumstances
      `BuildException` - if ignoreNoncriticalErrors has not been set to true and a directory could not be created, for instance because it was already existing. Precisely, the codes 521, 550 and 553 will trigger a BuildException

  - ### execute

    public void execute() throws BuildException
    Runs the task.
    Overrides:
      `execute` in class `Task`
    Throws:
      `BuildException` - if the task fails or is not configured correctly.

  - ### log

    void log(String msg, int level)